/*

 This software is in the public domain, furnished "as is", without technical  
 support, and with no warranty, express or implied, as to its usefulness for  
 any purpose.                 
                                                                          
 Second demo program for using a DAC MCP4725 to control a RC transmitter  
  
 This demo reads an ultrasonic module and moves a servo analog to the distance.

 Author: Dirk Wiedemann                                    
 Date: 2018/05/15                                       
 
 This sketch uses the library MyMCP4725 from Retian.                                               
 
*/

#include <Wire.h>
#include <MyMCP4725.h>

#define potiPin 0
#define i2cAdress 0x60

MyMCP4725 DAC(i2cAdress);

int Wert;
volatile uint16_t potiWert;
unsigned long startTime, endTime;
bool dacStatus = false;
int trigger=7; 
int echo=6;
long dauer=0; 
long entfernung=0;


void setup() {
  if (DAC.isReady())
  {
    dacStatus = true;
    DAC.setWireClock(400);   //setting I2C frequence to 400 kHz
  }
  pinMode(trigger, OUTPUT); 
  pinMode(echo, INPUT); 
}


void loop() {
  if (dacStatus) {
    // initiating and reading the ultrasonic module
    digitalWrite(trigger, LOW); 
    delay(5); 
    digitalWrite(trigger, HIGH); 
    delay(10);
    digitalWrite(trigger, LOW);
    dauer = pulseIn(echo, HIGH); 
    entfernung = (dauer/2) * 0.03432; 
    // setting the DAC
    if (entfernung <= 50 || entfernung >= 0) {
      setDAC(entfernung);
    }
  }
}

void setDAC(int Prozent) {
    potiWert = map(Prozent, 0, 50, 0, 4095);  // mapping the values from 0 to 50 to 12 bit resolution
    startTime = micros();
    DAC.setVoltage(potiWert, false); //setting the DAC; false = EEPROM wasn't written
    endTime = micros();

}

